package hwr;

import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;

public class BitmapCharDBReader {

    public static TreeMap<Character, ArrayList<BitmapCharacter>> getCharTreeMap(String fileName) {
        BitmapCharacterReader train = null;
        try {

            TreeMap<Character, ArrayList<BitmapCharacter>> charMap = new TreeMap<Character, ArrayList<BitmapCharacter>>();
            train = new BitmapCharacterReader(new FileReader(fileName));
            BitmapCharacter c = train.readBitmapCharacter();
            while (c != null) {
                if (!charMap.containsKey(c.getClassValue())) {
                    charMap.put(c.getClassValue(), new ArrayList<BitmapCharacter>());
                }
                charMap.get(c.getClassValue()).add(c);
                c = train.readBitmapCharacter();
            }
            train.close();
            return charMap;

        } catch (IOException ex) {
            Logger.getLogger(BitmapCharDBReader.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NumberFormatException ex) {
            Logger.getLogger(BitmapCharDBReader.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                train.close();
            } catch (IOException ex) {
                Logger.getLogger(BitmapCharDBReader.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return null;

    }
}
