package hwr;

import java.io.Serializable;

public class BitmapCharacter implements Serializable {

    private static final long serialVersionUID = -9096285490690924221L;
    private final byte[][] data;
    private final int pue;
    private final int ple;
    private final int dbu;
    private final char classValue;
    static private String newLine = "\n";

    public BitmapCharacter(byte[][] d, int pue, int ple, int dbu, char classValue) {
        data = d;
        this.pue = pue;
        this.ple = ple;
        this.dbu = dbu;
        this.classValue = classValue;
    }

    /**
     *  New functions: getData, getHeight, getWidth
     */
    public byte[][] getData() {
        return data;
    }

    public int getHeight() {
        return data.length;
    }

    public int getWidth() {
        return data[0].length;
    }

    /**
     * The method returns distance of the upper extreme from thebaseline, i.e. the line on which the words is written.
     */
    public int getPositionUpperExtreme() {
        return pue;
    }

    /**
     * The method returns the distance of the lower extreme from the baseline. 
     */
    public int getPositionLowerExtreme() {
        return ple;
    }

    /**
     * The method returns the distance between baseline and upperline.
     */
    public int getDistanceBaselineUpperline() {
        return dbu;
    }

    public byte get(int i, int j) throws ArrayIndexOutOfBoundsException {
        if (0 <= i && i < data.length && 0 <= j && j < data[i].length) {
            return data[i][j];
        } else {
            throw new ArrayIndexOutOfBoundsException("Kép túlindexelés!!! (i = " + i + ", j = " + j + ")");
        }
    }

    public char getClassValue() {
        return classValue;
    }

    @Override
    public String toString() {
        StringBuffer buffer = new StringBuffer();

        buffer.append(data[0].length + " " + data.length + " " + pue + " " + ple + " " + dbu + BitmapCharacter.newLine);
        for (int i = 0; i < data.length; i++) {
            for (int j = 0; j < data[i].length; j++) {
                buffer.append(data[i][j]);
            }
            buffer.append(BitmapCharacter.newLine);
        }
        buffer.append(classValue);

        return buffer.toString();
    }

    public static String getNewLine() {
        return BitmapCharacter.newLine;
    }

    public static void setNewLine(String newNewLine) {
        BitmapCharacter.newLine = newNewLine;
    }
}
