package hwr;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.Reader;

public class BitmapCharacterReader extends Reader {

    private BufferedReader input;

    public BitmapCharacterReader(Reader in) {
        if (in instanceof BufferedReader) {
            input = (BufferedReader) in;
        } else {
            input = new BufferedReader(in);
        }
    }

    @Override
    public void close() throws IOException {
        input.close();
    }

    @Override
    public int read(char[] arg0, int arg1, int arg2) throws IOException {
        return input.read(arg0, arg1, arg2);
    }

    public BitmapCharacter readBitmapCharacter() throws IOException, NumberFormatException {
        try {
            String firstLine = input.readLine();
            if (firstLine != null && firstLine.length() > 0) {
                String[] stat = firstLine.split(" ");
                int width = Integer.parseInt(stat[0]);
                int height = Integer.parseInt(stat[1]);
                byte[][] data = new byte[height][width];

                for (int i = 0; i < height; i++) {
                    String line = input.readLine();
                    for (int j = 0; j < width; j++) {
                        data[i][j] = (line.charAt(j) == '1') ? (byte) 1 : (byte) 0;
                    }
                }

                char classValue = input.readLine().charAt(0);

                return new BitmapCharacter(data, Integer.parseInt(stat[2]), Integer.parseInt(stat[3]), Integer.parseInt(stat[4]), classValue);
            } else {
                return null;
            }
        } catch (IOException ex) {
            return null;
        }
    }
}
