package hwr;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;

public class GUI extends javax.swing.JFrame implements Runnable, ActionListener {

    public DefaultListModel dbListModel;

    public GUI() {
        initComponents();
        dbListModel = new DefaultListModel();
        lstTrainDatabases.setModel(dbListModel);
        btnAddTrainDatabase.addActionListener(this);
        btnRemoveTrainDatabase.addActionListener(this);
        btnRunTest.addActionListener(this);
        btnSelectTestDatabase.addActionListener(this);
    }

    public void run() {
        this.setVisible(true);
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("SelectTestDatabase")) {
            JFileChooser fc = new JFileChooser();
            int rc = fc.showDialog(null, "Select Test Database");
            if (rc == JFileChooser.APPROVE_OPTION) {
                txtTestDatabase.setText(fc.getSelectedFile().getPath());
            }
        } else if (e.getActionCommand().equals("AddTrainDatabase")) {
            JFileChooser fc = new JFileChooser();
            int rc = fc.showDialog(null, "Select Train Database");
            if (rc == JFileChooser.APPROVE_OPTION) {
                dbListModel.addElement(fc.getSelectedFile().getPath());
            }
        } else if (e.getActionCommand().equals("RemoveTrainDatabase")) {
            try {
                dbListModel.remove(lstTrainDatabases.getSelectedIndex());
            } catch (Exception exp) {
            }
        } else if (e.getActionCommand().equals("RunTest")) {
            Launch.runTest();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        SplitPane = new javax.swing.JSplitPane();
        ProgressPanel = new javax.swing.JPanel();
        TotalPanel = new javax.swing.JPanel();
        prgTotal = new javax.swing.JProgressBar();
        jLabel1 = new javax.swing.JLabel();
        lblTestDatabaseSize = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        lblTotalTestedCharacters = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        lblRecognizedCharacters = new javax.swing.JLabel();
        lblFailedCharacters = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        lblTotalAccuracy = new javax.swing.JLabel();
        CurrentPanel = new javax.swing.JPanel();
        prgCurrent = new javax.swing.JProgressBar();
        jLabel11 = new javax.swing.JLabel();
        lblCurrentDatabaseSize = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        lblCurrentTestedCharacters = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        lblCurrentRecognizedCharacters = new javax.swing.JLabel();
        lblCurrentFailedCharacters = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        lblCurrentAccuracy = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        lblCurrentCharacter = new javax.swing.JLabel();
        OutputPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtOutput = new javax.swing.JTextArea();
        SettingsPanel = new javax.swing.JPanel();
        txtTestDatabase = new javax.swing.JTextField();
        btnSelectTestDatabase = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstTrainDatabases = new javax.swing.JList();
        btnAddTrainDatabase = new javax.swing.JButton();
        btnRemoveTrainDatabase = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        chbUseNormalizer = new javax.swing.JCheckBox();
        cmbRecognizer = new javax.swing.JComboBox();
        jLabel7 = new javax.swing.JLabel();
        btnRunTest = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        txtTrainOutput = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        txtCharAreaLimit = new javax.swing.JTextField();
        txtMinNearestCharCount = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("GUI");
        setMinimumSize(new java.awt.Dimension(700, 600));

        SplitPane.setBorder(null);
        SplitPane.setDividerLocation(350);
        SplitPane.setOpaque(false);

        ProgressPanel.setLayout(new java.awt.BorderLayout());

        TotalPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Total Progress"));

        jLabel1.setText("Test Database Size");

        lblTestDatabaseSize.setText("Unknown");

        jLabel3.setText("Tested Characters");

        lblTotalTestedCharacters.setText("Unknown");

        jLabel5.setText("Recognized Characters");

        jLabel6.setText("Failed Characters");

        lblRecognizedCharacters.setText("Unknown");

        lblFailedCharacters.setText("Unknown");

        jLabel9.setText("Accuracy");

        lblTotalAccuracy.setText("Unknown");

        javax.swing.GroupLayout TotalPanelLayout = new javax.swing.GroupLayout(TotalPanel);
        TotalPanel.setLayout(TotalPanelLayout);
        TotalPanelLayout.setHorizontalGroup(
            TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(TotalPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(prgTotal, javax.swing.GroupLayout.DEFAULT_SIZE, 397, Short.MAX_VALUE)
                    .addGroup(TotalPanelLayout.createSequentialGroup()
                        .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel3)
                            .addComponent(jLabel9))
                        .addGap(25, 25, 25)
                        .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(TotalPanelLayout.createSequentialGroup()
                                .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lblTestDatabaseSize)
                                    .addComponent(lblTotalTestedCharacters))
                                .addGap(18, 18, 18)
                                .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel5)
                                    .addComponent(jLabel6))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lblFailedCharacters)
                                    .addComponent(lblRecognizedCharacters)))
                            .addComponent(lblTotalAccuracy, javax.swing.GroupLayout.PREFERRED_SIZE, 223, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        TotalPanelLayout.setVerticalGroup(
            TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(TotalPanelLayout.createSequentialGroup()
                .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(TotalPanelLayout.createSequentialGroup()
                        .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(lblTestDatabaseSize))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(lblTotalTestedCharacters)))
                    .addGroup(TotalPanelLayout.createSequentialGroup()
                        .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel5)
                            .addComponent(lblRecognizedCharacters))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6)
                            .addComponent(lblFailedCharacters))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(prgTotal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(TotalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(lblTotalAccuracy)))
        );

        ProgressPanel.add(TotalPanel, java.awt.BorderLayout.NORTH);

        CurrentPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Current Progress"));

        jLabel11.setText("Test Database Size");

        lblCurrentDatabaseSize.setText("Unknown");

        jLabel13.setText("Tested Characters");

        lblCurrentTestedCharacters.setText("Unknown");

        jLabel15.setText("Recognized Characters");

        jLabel16.setText("Failed Characters");

        lblCurrentRecognizedCharacters.setText("Unknown");

        lblCurrentFailedCharacters.setText("Unknown");

        jLabel19.setText("Current Accuracy");

        lblCurrentAccuracy.setText("Unknown");

        jLabel21.setText("Current Character");

        lblCurrentCharacter.setText("Unknown");

        javax.swing.GroupLayout CurrentPanelLayout = new javax.swing.GroupLayout(CurrentPanel);
        CurrentPanel.setLayout(CurrentPanelLayout);
        CurrentPanelLayout.setHorizontalGroup(
            CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CurrentPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(prgCurrent, javax.swing.GroupLayout.DEFAULT_SIZE, 397, Short.MAX_VALUE)
                    .addGroup(CurrentPanelLayout.createSequentialGroup()
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel11)
                            .addComponent(jLabel13))
                        .addGap(25, 25, 25)
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblCurrentDatabaseSize)
                            .addComponent(lblCurrentTestedCharacters))
                        .addGap(18, 18, 18)
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel15)
                            .addComponent(jLabel16))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblCurrentFailedCharacters)
                            .addComponent(lblCurrentRecognizedCharacters)))
                    .addGroup(CurrentPanelLayout.createSequentialGroup()
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel19)
                            .addComponent(jLabel21))
                        .addGap(28, 28, 28)
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblCurrentCharacter, javax.swing.GroupLayout.DEFAULT_SIZE, 281, Short.MAX_VALUE)
                            .addComponent(lblCurrentAccuracy, javax.swing.GroupLayout.DEFAULT_SIZE, 281, Short.MAX_VALUE))))
                .addContainerGap())
        );
        CurrentPanelLayout.setVerticalGroup(
            CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CurrentPanelLayout.createSequentialGroup()
                .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(CurrentPanelLayout.createSequentialGroup()
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel11)
                            .addComponent(lblCurrentDatabaseSize))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel13)
                            .addComponent(lblCurrentTestedCharacters)))
                    .addGroup(CurrentPanelLayout.createSequentialGroup()
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel15)
                            .addComponent(lblCurrentRecognizedCharacters))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel16)
                            .addComponent(lblCurrentFailedCharacters))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(prgCurrent, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel19)
                    .addComponent(lblCurrentAccuracy))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(CurrentPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel21)
                    .addComponent(lblCurrentCharacter)))
        );

        ProgressPanel.add(CurrentPanel, java.awt.BorderLayout.SOUTH);

        OutputPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Output"));
        OutputPanel.setLayout(new java.awt.BorderLayout());

        txtOutput.setColumns(20);
        txtOutput.setRows(5);
        jScrollPane1.setViewportView(txtOutput);

        OutputPanel.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        ProgressPanel.add(OutputPanel, java.awt.BorderLayout.CENTER);

        SplitPane.setRightComponent(ProgressPanel);

        SettingsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Settings"));
        SettingsPanel.setMinimumSize(new java.awt.Dimension(250, 250));
        SettingsPanel.setPreferredSize(new java.awt.Dimension(300, 300));
        SettingsPanel.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(txtTestDatabase, gridBagConstraints);

        btnSelectTestDatabase.setText("Browse");
        btnSelectTestDatabase.setActionCommand("SelectTestDatabase");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(btnSelectTestDatabase, gridBagConstraints);

        lstTrainDatabases.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        lstTrainDatabases.setPreferredSize(null);
        jScrollPane2.setViewportView(lstTrainDatabases);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(jScrollPane2, gridBagConstraints);

        btnAddTrainDatabase.setText("Add");
        btnAddTrainDatabase.setActionCommand("AddTrainDatabase");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(btnAddTrainDatabase, gridBagConstraints);

        btnRemoveTrainDatabase.setText("Remove");
        btnRemoveTrainDatabase.setActionCommand("RemoveTrainDatabase");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(btnRemoveTrainDatabase, gridBagConstraints);

        jLabel2.setText("Test Database");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(jLabel2, gridBagConstraints);

        jLabel4.setText("Train Databases");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(12, 2, 2, 2);
        SettingsPanel.add(jLabel4, gridBagConstraints);

        chbUseNormalizer.setText("Use Normalizer");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(12, 2, 2, 2);
        SettingsPanel.add(chbUseNormalizer, gridBagConstraints);

        cmbRecognizer.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "LimitedBest_ManhattanDistanceRecognizer", "Best_ManhattanDistanceRecognizer", "BestManhattanDistanceRecognizer" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(cmbRecognizer, gridBagConstraints);

        jLabel7.setText("Recognizer");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(12, 2, 2, 2);
        SettingsPanel.add(jLabel7, gridBagConstraints);

        btnRunTest.setText("Run Test");
        btnRunTest.setActionCommand("RunTest");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(12, 2, 2, 2);
        SettingsPanel.add(btnRunTest, gridBagConstraints);

        txtTrainOutput.setColumns(20);
        txtTrainOutput.setRows(5);
        txtTrainOutput.setText("Mesterséges Intelligencia II\n\nBuczkó Tamás");
        jScrollPane3.setViewportView(txtTrainOutput);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(12, 2, 2, 2);
        SettingsPanel.add(jScrollPane3, gridBagConstraints);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 71, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 101, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(jPanel2, gridBagConstraints);

        txtCharAreaLimit.setText("5");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(txtCharAreaLimit, gridBagConstraints);

        txtMinNearestCharCount.setText("3");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(txtMinNearestCharCount, gridBagConstraints);

        jLabel8.setText("Minimal Nearest Character Count");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(jLabel8, gridBagConstraints);

        jLabel10.setText("Stop Searching If Character Closer Than (%)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        SettingsPanel.add(jLabel10, gridBagConstraints);

        SplitPane.setLeftComponent(SettingsPanel);

        getContentPane().add(SplitPane, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-800)/2, (screenSize.height-600)/2, 800, 600);
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel CurrentPanel;
    private javax.swing.JPanel OutputPanel;
    private javax.swing.JPanel ProgressPanel;
    private javax.swing.JPanel SettingsPanel;
    private javax.swing.JSplitPane SplitPane;
    private javax.swing.JPanel TotalPanel;
    private javax.swing.JButton btnAddTrainDatabase;
    private javax.swing.JButton btnRemoveTrainDatabase;
    private javax.swing.JButton btnRunTest;
    private javax.swing.JButton btnSelectTestDatabase;
    public javax.swing.JCheckBox chbUseNormalizer;
    public javax.swing.JComboBox cmbRecognizer;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    public javax.swing.JLabel lblCurrentAccuracy;
    public javax.swing.JLabel lblCurrentCharacter;
    public javax.swing.JLabel lblCurrentDatabaseSize;
    public javax.swing.JLabel lblCurrentFailedCharacters;
    public javax.swing.JLabel lblCurrentRecognizedCharacters;
    public javax.swing.JLabel lblCurrentTestedCharacters;
    public javax.swing.JLabel lblFailedCharacters;
    public javax.swing.JLabel lblRecognizedCharacters;
    public javax.swing.JLabel lblTestDatabaseSize;
    public javax.swing.JLabel lblTotalAccuracy;
    public javax.swing.JLabel lblTotalTestedCharacters;
    public javax.swing.JList lstTrainDatabases;
    public javax.swing.JProgressBar prgCurrent;
    public javax.swing.JProgressBar prgTotal;
    public javax.swing.JTextField txtCharAreaLimit;
    public javax.swing.JTextField txtMinNearestCharCount;
    public javax.swing.JTextArea txtOutput;
    public javax.swing.JTextField txtTestDatabase;
    private javax.swing.JTextArea txtTrainOutput;
    // End of variables declaration//GEN-END:variables
}
