package hwr.featurizer;

import hwr.BitmapCharacter;

import java.util.TreeMap;
import java.util.ArrayList;

public class Featurizer {

    private static ArrayList<FeaturizerModule> modules = new ArrayList<FeaturizerModule>();

    public static void addModule(FeaturizerModule module) {
        modules.add(module);
    }

    public static TreeMap<Character, ArrayList<ArrayList<Double>>> featurize(TreeMap<Character, ArrayList<BitmapCharacter>> charMap) {

        TreeMap<Character, ArrayList<ArrayList<Double>>> featMap = new TreeMap<Character, ArrayList<ArrayList<Double>>>();

        for (Character key : charMap.keySet()) {

//            if(Character.isLowerCase(key)) {
//                continue;
//            }

            ArrayList<ArrayList<Double>> charFeatArrayList;

//            charFeatArrayList = new ArrayList<ArrayList<Double>>();
//            featMap.put(key, charFeatArrayList);

            if (!featMap.keySet().contains(Character.toUpperCase(key))) {
                charFeatArrayList = new ArrayList<ArrayList<Double>>();
                featMap.put(Character.toUpperCase(key), charFeatArrayList);
            } else {
                charFeatArrayList = featMap.get(Character.toUpperCase(key));
            }

            for (BitmapCharacter bmChar : charMap.get(key)) {
                charFeatArrayList.add(featurize(bmChar));
            }
        }

        return featMap;
    }

    public static ArrayList<Double> featurize(BitmapCharacter bmChar) {
        ArrayList<Double> features = new ArrayList<Double>();
        for (FeaturizerModule module : modules) {
            features.add(module.featurize(bmChar));
        }
        return features;
    }
}
