package hwr.featurizer;

import hwr.BitmapCharacter;

public class GridPixelRateFeature implements FeaturizerModule {

    private int rowNum,  columnNum,  rowIndex,  columnIndex;

    public GridPixelRateFeature(int rowNum, int columnNum, int rowIndex, int columnIndex) {
        this.rowNum = rowNum;
        this.columnNum = columnNum;
        this.rowIndex = rowIndex;
        this.columnIndex = columnIndex;
    }

    public double featurize(BitmapCharacter bmChar) {

        int width = bmChar.getWidth();
        int height = bmChar.getHeight();

        int W = width / columnNum;
        int H = height / rowNum;

        int sum = 0;
        int count = 0;

        byte[][] charMatrix = bmChar.getData();

        for (int i = 0; i < W; i++) {
            for (int j = 0; j < H; j++) {
                sum += charMatrix[rowIndex * H + j][columnIndex * W + i];
                count++;
            }
        }

        return (double) sum / (double) count;
    }
}
