package hwr.featurizer;

import hwr.BitmapCharacter;

public class VMirrorFeature implements FeaturizerModule {

    private double weight;

    public VMirrorFeature(double weight) {
        this.weight = weight;
    }

    public double featurize(BitmapCharacter bmChar) {
        double blackPixelCount = 0;
        double mirrorPixelCoumt = 0;
        byte[][] data = bmChar.getData();
        for (int i = 0; i < bmChar.getHeight(); i++) {
            for (int j = 0; j < bmChar.getWidth(); j++) {
                if (data[i][j] == 1) {
                    blackPixelCount++;
                    if (i < bmChar.getWidth() / 2) {
                        if (data[i][bmChar.getWidth() - j - 1] == 1) {
                            mirrorPixelCoumt += 2;
                        }
                    }
                }
            }
        }
        return (mirrorPixelCoumt / blackPixelCount) * weight;
    }
}
