package hwr.normalizer;

import hwr.BitmapCharacter;

public class RectangleNormalizer implements NormalizerModule {

    public BitmapCharacter normalize(BitmapCharacter bmChar) {

        int width = bmChar.getWidth();
        int height = bmChar.getHeight();

        byte[][] originalMatrix = bmChar.getData();

        byte[][] newMatrix = new byte[width >= height ? width : height][width >= height ? width : height];

        if (width >= height) {
            int offset = (width - height) / 2;
            for (int row = 0; row < height; row++) {
                newMatrix[row + offset] = originalMatrix[row];
            }
        } else {
            int offset = (height - width) / 2;
            for (int col = 0; col < width; col++) {
                newMatrix[col + offset] = originalMatrix[col];
            }
        }

        return new BitmapCharacter(newMatrix,
                bmChar.getPositionUpperExtreme(),
                bmChar.getPositionLowerExtreme(),
                bmChar.getDistanceBaselineUpperline(),
                bmChar.getClassValue());

    }
}
