package hwr.recognizer;

import java.util.TreeMap;
import java.util.ArrayList;

public class BestManhattanDistanceRecognizer implements RecognizerModule {

    TreeMap<Character, ArrayList<ArrayList<Double>>> featMap;

    public void learn(TreeMap<Character, ArrayList<ArrayList<Double>>> featMap) {
        this.featMap = featMap;
    }

    public Character recognize(ArrayList<Double> featArrayList) {

        char bestChar = 'X';
        double bestManhattanDistance = Double.MAX_VALUE;

        for (Character key : featMap.keySet()) {

            ArrayList<ArrayList<Double>> charFeatArrayList = featMap.get(key);

            for (ArrayList<Double> sampleArrayList : charFeatArrayList) {

                double manhattanDistance = 0;

                for (int i = 0; i < featArrayList.size(); i++) {
                    manhattanDistance += Math.abs(sampleArrayList.get(i) - featArrayList.get(i));
                }

                if (manhattanDistance < bestManhattanDistance) {
                    bestManhattanDistance = manhattanDistance;
                    bestChar = key;
                }

            }


        }

        return bestChar;
    }
}

