package hwr.recognizer;

import java.util.TreeMap;
import java.util.ArrayList;

public class Best_ManhattanDistanceRecognizer implements RecognizerModule {

    TreeMap<Character, ArrayList<ArrayList<Double>>> featMap;
    private int count;

    public Best_ManhattanDistanceRecognizer(int count) {
        this.count = count;
    }

    public void learn(TreeMap<Character, ArrayList<ArrayList<Double>>> featMap) {
        this.featMap = featMap;
    }

    public Character recognize(ArrayList<Double> featArrayList) {

        ArrayList<Character> charArray = new ArrayList<Character>();
        ArrayList<Double> distArray = new ArrayList<Double>();
        int featureSize = featMap.get(featMap.firstKey()).get(0).size();
        ArrayList<ArrayList<Double>> charFeatArrayList;
        double bestManhattanDistance;
        double manhattanDistance;
        int bestIndex;

        TreeMap<Character, Integer> charMap = new TreeMap<Character, Integer>();

        for (Character key : featMap.keySet()) {
            charMap.put(key, 0);
            charFeatArrayList = featMap.get(key);
            for (ArrayList<Double> sampleArrayList : charFeatArrayList) {
                manhattanDistance = 0;
                for (int i = 0; i < featureSize; i++) {
                    manhattanDistance += Math.abs(sampleArrayList.get(i) - featArrayList.get(i));
                }
                charArray.add(key);
                distArray.add(manhattanDistance);
            }
        }

        while (true) {
            bestManhattanDistance = Double.MAX_VALUE;
            bestIndex = 0;
            for (int i = 0; i < distArray.size(); i++) {
                if (distArray.get(i) < bestManhattanDistance) {
                    bestManhattanDistance = distArray.get(i);
                    bestIndex = i;
                }
            }
            charMap.put(charArray.get(bestIndex), charMap.get(charArray.get(bestIndex)) + 1);
            if (charMap.get(charArray.get(bestIndex)) == count) {
                return charArray.get(bestIndex);
            }
            charArray.remove(bestIndex);
            distArray.remove(bestIndex);
        }
    }
}

